<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                      ***
  ***      File:  admin_layouts.php                                        ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                 ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/sorter.php");
	include($root_folder_path . "includes/navigator.php");

	check_admin_security("layouts");

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main","admin_layouts.html");

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_layout_href", "admin_layout.php");
	$t->set_var("admin_layout_header_href", "admin_layout_header.php");
	$t->set_var("admin_layout_page_href", "admin_layout_page.php");
	$t->set_var("admin_items_list_href", "admin_items_list.php");
	$t->set_var("admin_layouts_url", urlencode("admin_layouts.php"));

	$s = new VA_Sorter($settings["admin_templates_dir"], "sorter_img.html", "admin_layouts.php");
	$s->set_sorter("ID", "sorter_layout_id", "1", "layout_id");
	$s->set_sorter("Layout Name", "sorter_layout_name", "2", "layout_name");

	$n = new VA_Navigator($settings["admin_templates_dir"], "navigator.html", "admin_layouts.php");

	include("./admin_header.php");
	include("./admin_footer.php");

	// set up variables for navigator
	$db->query("SELECT COUNT(*) FROM " . $table_prefix . "layouts");
	$db->next_record();
	$total_records = $db->f(0);
	$records_per_page = 25;
	$pages_number = 5;
	$page_number = $n->set_navigator("navigator", "page", SIMPLE, $pages_number, $records_per_page, $total_records, false);

	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	$db->query("SELECT * FROM " . $table_prefix . "layouts " . $s->order_by);
	if($db->next_record())
	{
		$t->set_var("no_records", "");
		do
		{
			$layout_id = $db->f("layout_id");
			$layout_name = $db->f("layout_name");
			$style_name = $db->f("style_name");

			$t->set_var("layout_id", $layout_id);

			$style_lc = strtolower($style_name);
			if ($dir = @opendir($root_folder_path . "styles")) 
			{
				$dir_values = array();
				while($file = readdir($dir)) {
					if ( preg_match("/^" . $style_lc . "\_/", $file) ) { 
						$dir_values[] = $file;
			    } 
			  }  
				closedir($dir);
				if(sizeof($dir_values) > 1) {
					$layout_name .= " :: <a href=\"admin_layout_scheme.php?layout_id=" . $layout_id . "\">Change Active Scheme</a>";
				}
			}
			
			if ( $settings["layout_id"] == $layout_id ) {
				$layout_status = "<b>Active</b>";
				$t->set_var("active_style", "");
				//$t->parse("active_rows",false);
			} else {
				$layout_status = "<a class=\"small\" href=\"admin_layout.php?set_layout_id=" . $layout_id . "\">Make Active</a>";
				$t->set_var("active_style", "nonactive");
				//$t->set_var("active_rows","<td colspan=6></td>");
			}

			$t->set_var("layout_name", $layout_name);
			$t->set_var("layout_status", $layout_status);
			
			$t->parse("records", true);
		} while($db->next_record());
	}
	else
	{
		$t->set_var("records", "");
		$t->set_var("navigator", "");
		$t->parse("no_records", false);
	}

	// Get menus
	$t->set_var("admin_menu_href", "admin_menu.php");
	$t->set_var("admin_menu_items", "admin_menu_items.php");
	
	$sql  = " SELECT * FROM " . $table_prefix . "menus";
	$sql .= " ORDER BY menu_title ";
	$db->query($sql);
	$menus = array();
	$menu_count = 0;
	if ($db->next_record()) {
		do {
			++$menu_count;
			$t->set_var("menu_count", $menu_count);
			$t->set_var("menu_id", $db->f("menu_id"));
			$t->set_var("menu_name", $db->f("menu_name"));
			$t->set_var("menu_title", $db->f("menu_title"));
			$t->set_var("menu_notes", $db->f("menu_notes"));
			
			$t->parse("menus_records", true);
		} while($db->next_record());
		$t->parse("menus", false);
	} else {
		$t->set_var("menus", "");
	}
	
	if ($va_type == "enterprise") {
		$t->sparse("products_pages", false);
		$t->sparse("users_pages", false);
		$t->sparse("helpdesk_pages", false);
		$t->sparse("forum_pages", false);
		$t->sparse("manuals_pages", false);
		$t->sparse("ads_pages", false);
	} else if ($va_type == "standard") {
		$t->sparse("products_pages", false);
		$t->sparse("users_pages", false);
		$t->sparse("forum_pages", false);
	} else if ($va_type == "light") {
		$t->sparse("products_pages", false);
		$t->sparse("users_pages", false);
	} else if ($va_type == "cms") {
		$t->sparse("forum_pages", false);
		$t->parse("manuals_pages", false);
	} else if ($va_type == "helpdesk") {
		$t->parse("helpdesk_pages", false);
		$t->sparse("forum_pages", false);
		$t->parse("manuals_pages", false);
	}

	

	$t->pparse("main");

?>