<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                        ***
  ***      File:  admin_shipping_module.php                                ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                  ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");
	include($root_folder_path . "includes/editgrid.php");

	check_admin_security("shipping_methods");

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_shipping_module.html");

	// set up html form parameters
	$r = new VA_Record($table_prefix . "shipping_modules");
	$r->add_where("shipping_module_id", INTEGER);
	$r->change_property("shipping_module_id", USE_IN_INSERT, true);
	$r->add_checkbox("is_active", INTEGER);
	$r->add_textbox("shipping_module_name", TEXT, "Shipping Module Name");
	$r->change_property("shipping_module_name", REQUIRED, true);
	$r->add_textbox("module_notes", TEXT, "Module Notes");

	$r->add_checkbox("is_external", TEXT);
	$r->add_textbox("php_external_lib", TEXT, "PHP External Library");
	$r->add_textbox("external_url", TEXT, "External URL");
	$r->add_textbox("tracking_url", TEXT, "Tracking URL");
	$is_external = get_param("is_external");
	if ($is_external) {
		$r->change_property("php_external_lib", REQUIRED, true);
	}
	$r->get_form_values();

	$rp = new VA_Record($table_prefix . "shipping_modules_parameters", "parameters");
	$rp->add_where("parameter_id", INTEGER);
	$rp->add_hidden("shipping_module_id", INTEGER);
	$rp->change_property("shipping_module_id", USE_IN_INSERT, true);
	$rp->add_textbox("parameter_name", TEXT, "Parameter Name");
	$rp->change_property("parameter_name", REQUIRED, true);
	$rp->add_textbox("parameter_source", TEXT, "Parameter Source");
	$rp->add_checkbox("not_passed", INTEGER, "Not Passed");
	
	$shipping_module_id = get_param("shipping_module_id");

	$more_parameters = get_param("more_parameters");
	$number_parameters = get_param("number_parameters");

	$eg = new VA_EditGrid($rp, "parameters");
	$eg->get_form_values($number_parameters);

	$operation = get_param("operation");

	$return_page = "admin_shipping_modules.php";

	if(strlen($operation) && !$more_parameters)
	{
		if($operation == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}
		else if($operation == "delete" && $shipping_module_id)
		{
			$db->query("DELETE FROM " . $table_prefix . "shipping_modules WHERE shipping_module_id=" . $db->tosql($shipping_module_id, INTEGER));		
			$db->query("DELETE FROM " . $table_prefix . "shipping_modules_parameters WHERE shipping_module_id=" . $db->tosql($shipping_module_id, INTEGER));		
			header("Location: " . $return_page);
			exit;
		}

		$is_valid = $r->validate();
		$is_valid = ($eg->validate() && $is_valid); 

		if($is_valid)
		{
			if(strlen($shipping_module_id))
			{
				$r->update_record();
				$eg->set_values("shipping_module_id", $shipping_module_id);
				$eg->update_all($number_parameters);
			}
			else
			{
				$db->query("SELECT MAX(shipping_module_id) FROM " . $table_prefix . "shipping_modules");
				$db->next_record();
				$shipping_module_id = $db->f(0) + 1;
				$r->set_value("shipping_module_id", $shipping_module_id);
				$r->insert_record();
				$eg->set_values("shipping_module_id", $shipping_module_id);
				$eg->insert_all($number_parameters);
			}

			header("Location: " . $return_page);
			exit;
		}
	}
	else if(strlen($shipping_module_id) && !$more_parameters)
	{
		$r->get_db_values();
		$eg->set_value("shipping_module_id", $shipping_module_id);
		$eg->change_property("parameter_id", USE_IN_SELECT, true);
		$eg->change_property("parameter_id", USE_IN_WHERE, false);
		$eg->change_property("shipping_module_id", USE_IN_WHERE, true);
		$eg->change_property("shipping_module_id", USE_IN_SELECT, true);
		$number_parameters = $eg->get_db_values();
		if($number_parameters == 0)
			$number_parameters = 5;
	}
	else if($more_parameters)
	{
		$number_parameters += 5;
	}
	else
	{
		$number_parameters = 5;
	}

	$t->set_var("number_parameters", $number_parameters);
	$eg->set_parameters_all($number_parameters);
	$r->set_parameters();

	if(strlen($shipping_module_id))	
	{
		$t->set_var("save_button", "Update");
	}
	else
	{
		$t->set_var("save_button", "Add New");	
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_shipping_modules_href", "admin_shipping_modules.php");
	$t->set_var("admin_shipping_module_href",  "admin_shipping_module.php");

	$t->pparse("main");

?>