<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                       ***
  ***      File:  block_products_top_sellers.php                           ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                 ***
  ***                                                                      ***
  ****************************************************************************
*/


function products_top_sellers($block_name)
{
	global $t, $db, $table_prefix, $db_type;
	global $settings, $page_settings;
	global $language_code;
	global $currency_left, $currency_right, $currency_rate;

	if (get_setting_value($page_settings, $block_name . "_column_hide", 0)) {
		return;
	}

	$user_info = get_session("session_user_info");
	$user_tax_free = get_setting_value($user_info, "tax_free", 0);
	$discount_type = get_session("session_discount_type");
	$discount_amount = get_session("session_discount_amount");
	$friendly_urls = get_setting_value($settings, "friendly_urls", 0);
	$friendly_extension = get_setting_value($settings, "friendly_extension", "");
	$product_no_image = get_setting_value($settings, "product_no_image", "");
	$bestsellers_records = get_setting_value($page_settings, "bestsellers_records", 10);
	$bestsellers_days    = get_setting_value($page_settings, "bestsellers_days",    7);
	$bestsellers_status  = get_setting_value($page_settings, "bestsellers_status",  "");
	$bestsellers_image = get_setting_value($page_settings, "bestsellers_image",  0);
	$bestsellers_desc = get_setting_value($page_settings, "bestsellers_desc", 0);
	$display_products = get_setting_value($settings, "display_products", 0);
	$user_id = get_session("session_user_id");		
	$user_type_id = get_session("session_user_type_id");		
	$price_type = get_session("session_price_type");
	if ($price_type == 1) {
		$price_field = "trade_price";
		$sales_field = "trade_sales";
	} else {
		$price_field = "price";
		$sales_field = "sales_price";
	}
	$image_field = ""; $image_alt_field = ""; $desc_field = "";
	if ($bestsellers_image == 1) {
		$image_field = "tiny_image";
		$image_alt_field = "tiny_image_alt";
	} elseif ($bestsellers_image == 2) {
		$image_field = "small_image";
		$image_alt_field = "small_image_alt";
	} elseif ($bestsellers_image == 3) {
		$image_field = "big_image";
		$image_alt_field = "big_image_alt";
	} elseif ($bestsellers_image == 4) {
		$image_field = "super_image";
		$image_alt_field = "big_image_alt";
	}
	if ($bestsellers_desc == 1) {
		$desc_field = "short_description";
	} elseif ($bestsellers_desc == 2) {
		$desc_field = "full_description";
	} elseif ($bestsellers_desc == 3) {
		$desc_field = "features";
	} elseif ($bestsellers_desc == 4) {
		$desc_field = "special_offer";
	}

	$bestsellers_time = mktime(0,0,0, date("m"), date("d") - intval($bestsellers_days), date("Y"));
	$order_placed_date = va_time($bestsellers_time);

	$t->set_file("block_body", "block_top_sellers.html");
	$t->set_var("top_category_name", PRODUCTS_TITLE);
	$t->set_var("TOP_SELLERS_TITLE", TOP_SELLERS_TITLE);
	$t->set_var("top_sellers_items",  "");

	$sql  = " SELECT COUNT(i.item_id) AS total_bought, i.item_id, i.item_type_id, i.item_name, i.friendly_url,";
	$sql .= " i." . $price_field . ", i.properties_price, i.is_sales, i." . $sales_field . ", i.buying_price, i.tax_free, ";
	$sql .= " ip.price AS user_price, ip.discount_action AS user_price_action ";
	if ($image_field) { $sql .= " , " . $image_field; }
	if ($image_alt_field) { $sql .= " , " . $image_alt_field; }
	if ($desc_field) { $sql .= " , " . $desc_field; }
	$sql .= " FROM (((" . $table_prefix . "items i ";
	$sql .= " INNER JOIN " . $table_prefix . "orders_items oi ON i.item_id=oi.item_id) ";
	$sql .= " INNER JOIN " . $table_prefix . "orders o ON oi.order_id=o.order_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "items_prices ip ON (i.item_id=ip.item_id AND ip.min_quantity=1 AND ip.user_type_id=" . $db->tosql($user_type_id, INTEGER) . ")) ";
	//$sql .= " WHERE i.item_id=oi.item_id AND oi.order_id=o.order_id ";
	$sql .= " WHERE i.is_showing=1 AND i.is_approved=1 AND ((i.hide_out_of_stock=1 AND i.stock_level > 0) OR i.hide_out_of_stock=0)";
	$sql .= " AND (i.language_code IS NULL OR i.language_code='' OR i.language_code=" . $db->tosql($language_code, TEXT) . ")";
	$sql .= " AND o.order_placed_date >=" . $db->tosql($order_placed_date, DATETIME);
	if (strlen($bestsellers_status)) {
		$sql .= " AND o.order_status=" . $db->tosql($bestsellers_status, INTEGER);
	}
	$sql .= " GROUP BY i.item_id, i.item_type_id, i.item_name, i.friendly_url, i." . $price_field . ", i.properties_price, i.is_sales, i." . $sales_field . ", i.buying_price, ip.price, ip.discount_action, i.tax_free ";
	if ($image_field) { $sql .= " , " . $image_field; }
	if ($image_alt_field) { $sql .= " , " . $image_alt_field; }
	if ($desc_field) { $sql .= " , " . $desc_field; }
	if ($db_type == "access") {
		$sql .= " ORDER BY COUNT(i.item_id) DESC ";
	} else {
		$sql .= " ORDER BY total_bought DESC ";
	}

	$db->RecordsPerPage = $bestsellers_records;
	$db->PageNumber = 1;
	$db->query($sql);
	if ($db->next_record())
	{
		$item_number = 0;
		do
		{
			$item_number++;
			$item_id = $db->f("item_id");
			$item_type_id = $db->f("item_type_id");
			$item_name = get_translation($db->f("item_name"));
			$friendly_url = $db->f("friendly_url");
			$item_image = ""; $item_image_alt = ""; $item_desc = "";
			if ($image_field) {
				$item_image = $db->f($image_field);	
				$item_image_alt = $db->f($image_alt_field);	
				if (!$item_image) {
					$item_image = $product_no_image;
				}
			}
			if ($desc_field) {
				$item_desc = $db->f($desc_field);	
			}

			if ($friendly_urls && $friendly_url) {
				$details_href = $friendly_url . $friendly_extension;
			} else {
				$details_href = "product_details.php?item_id=".urlencode($item_id);
			}
			$t->set_var("details_href", $details_href);

			if ($item_image)
			{
				if (preg_match("/^http\:\/\//", $item_image)) {
					$image_size = "";
				} else {
					$image_size = @GetImageSize($item_image);
					if (isset($restrict_products_images) && $restrict_products_images) { $item_image = "image_show.php?item_id=".$item_id."&type=small"; }
				}
				if (!strlen($item_image_alt)) { $item_image_alt = $item_name; }
				$t->set_var("alt", htmlspecialchars($item_image_alt));
				$t->set_var("src", htmlspecialchars($item_image));
				if (is_array($image_size)) {
					$t->set_var("width", "width=\"" . $image_size[0] . "\"");
					$t->set_var("height", "height=\"" . $image_size[1] . "\"");
				} else {
					$t->set_var("width", "");
					$t->set_var("height", "");
				}
				$t->sparse("top_image", false);
			} else {
				$t->set_var("top_image", "");
			}
			if ($item_desc) {
				$t->set_var("desc_text", $item_desc);
				$t->sparse("top_desc", false);
			} else {
				$t->set_var("top_desc", "");
			}

			$t->set_var("top_position", $item_number);
			$t->set_var("top_name", $item_name);

			if ($display_products != 2 || strlen($user_id)) 
			{
				$tax_free = $db->f("tax_free");
				if ($user_tax_free) { $tax_free = $user_tax_free; }
				$price = $db->f($price_field);
				$is_sales = $db->f("is_sales");
				$sales_price = $db->f($sales_field);
				$buying_price = $db->f("buying_price");
				$user_price = $db->f("user_price");
				$user_price_action = $db->f("user_price_action");
				$properties_price = $db->f("properties_price");
				if ($user_price > 0 && ($user_price_action > 0 || !$discount_type)) {
					if ($is_sales && $sales_price > 0) {
						$sales_price = $user_price;
					} else {
						$price = $user_price;
					}
				}

				if ($is_sales && $sales_price > 0) {
					$price = $sales_price;
				}
				if ($user_price_action != 1) {
					if ($discount_type == 1 || $discount_type == 3) {
						$price -= round(($price * $discount_amount) / 100, 2);
					} elseif ($discount_type == 2) {
						$price -= round($discount_amount, 2);
					} elseif ($discount_type == 4) {
						$price -= round((($price - $buying_price) * $discount_amount) / 100, 2);
					}
				}
				// add options and components prices
				$price += $properties_price;

				$price = $price * $currency_rate;

				set_tax_price($item_id, $item_type_id, $price, 0, $tax_free, "top_value", "", "top_tax_price", false);

				$t->sparse("top_value_block", false);
			}

			$t->parse("top_sellers_items", true);
		} while ($db->next_record());
		            	
		$t->parse("block_body", false);
		$t->parse($block_name, true);
	}
}

?>